## gammaray 1.1.98

=== CMakeLists.txt ===
# This is the top-level CMakeLists.txt file for the GammaRay project.
#
# Pass the following variables to cmake to control the build:
#
# -DGAMMARAY_UNKNOWN_CXX_MANGLED_NAMES=[on|off]
#  Set this if your compiler uses an unsupported C++ name mangling scheme
#  Default=off
#
# To build the man page from POD, run 'make man' after CMake (assumes perl is available)
# To install the resulting man page, run 'make install'
# Not available on Windows.
#
# To build the apidox, run 'make docs' after CMake (assumes doxygen is available)
# Not available on Windows.
#

project(GammaRay)
cmake_minimum_required(VERSION 2.8)

if(NOT Prog_NAME)
  set(Prog_NAME "GammaRay")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/ ${CMAKE_MODULE_PATH})

set(GAMMARAY_VERSION_MAJOR "1")
set(GAMMARAY_VERSION_MINOR "2")
set(GAMMARAY_VERSION_PATCH "50")
set(GAMMARAY_VERSION "${GAMMARAY_VERSION_MAJOR}.${GAMMARAY_VERSION_MINOR}.${GAMMARAY_VERSION_PATCH}")
set(GAMMARAY_VERSION_STRING "${GAMMARAY_VERSION}")

set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)

enable_testing()

if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
  find_package(Git)
  if(GIT_FOUND)
    execute_process(
      COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
      OUTPUT_VARIABLE _git_revision
    )
    string(REGEX REPLACE "\n" "" _git_revision "${_git_revision}")
    set(GAMMARAY_VERSION_STRING "${GAMMARAY_VERSION_STRING} (revision: ${_git_revision})")
  endif()
endif()

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "" FORCE)
endif()

message(STATUS "Building ${Prog_NAME} ${GAMMARAY_VERSION_STRING} in ${CMAKE_BUILD_TYPE} mode")
add_definitions(-DPROGRAM_NAME=\"${Prog_NAME}\")
add_definitions(-DQT_USE_FAST_CONCATENATION -DQT_USE_FAST_OPERATOR_PLUS -DQT_STRICT_ITERATORS)

include(CheckCXXCompilerFlag)
include(CheckLibraryExists)
include(GammaRayMacros)
include(MacroLogFeature)

set(QT_MIN_VERSION "4.7.0")
find_package(Qt5Transitional REQUIRED
  Core
  Gui
  Svg
  Test
)

# TODO: Remove me once fixed in ECM module
if(Qt5Core_FOUND)
  # Avoid errors and build in PIC mode:
  # qt5/qtbase/include/QtCore/qglobal.h:1765:4: error:
  #   #error "You must build your code with position independent code if Qt was
  #   built with -reduce-relocations. " "Compile your code with -fPIC or -fPIE."
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")

  # more hacks: find qpa/... includes
  # also see https://codereview.qt-project.org/#change,30483
  include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})
endif()

if(CMAKE_BUILD_TYPE MATCHES "^[Rr]elease$")
  add_definitions(-DQT_NO_DEBUG_OUTPUT)
endif()

set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)")
set(LIB_INSTALL_DIR "lib${LIB_SUFFIX}")
set(PLUGIN_INSTALL_DIR "${LIB_INSTALL_DIR}/qt4/plugins")

set(
  INSTALL_TARGETS_DEFAULT_ARGS
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION ${LIB_INSTALL_DIR}
  ARCHIVE DESTINATION ${LIB_INSTALL_DIR} COMPONENT Devel
)

macro_log_feature(
  QT_QTSCRIPTTOOLS_FOUND
  "Script engine debugger in Qt"
  "A debugger for QtScript"
  "included with Qt"
  FALSE
  ""
  "Required for the script engine debugger tool"
)

macro_log_feature(
  QT_QTWEBKIT_FOUND
  "WebKit in Qt"
  "A Qt-based web browser engine"
  "included with Qt"
  FALSE
  ""
  "Required for the webinspector tool"
)

find_path(
  QT_PRIVATE_INCLUDE_DIR private/qobject_p.h
  PATHS ${QT_INCLUDES}
)
if(QT_PRIVATE_INCLUDE_DIR)
  # not enough, some of them include harfbuzz headers, so we need to find those as well
  # for now we assume a regular Qt4 source build layout, but that probably should be generalized
  find_path(
    HARFBUZZ_INCLUDE_DIR harfbuzz.h
    PATH ${QT_PRIVATE_INCLUDE_DIR}/../../src/3rdparty/harfbuzz/src
  )
endif()

if(QT_PRIVATE_INCLUDE_DIR AND HARFBUZZ_INCLUDE_DIR)
  set(HAVE_PRIVATE_QT_HEADERS TRUE)
  include_directories(${HARFBUZZ_INCLUDE_DIR})
else()
  set(HAVE_PRIVATE_QT_HEADERS FALSE)
  # needs to go before Qt includes, in case we have non-working headers with the same name there
  include_directories(BEFORE ${CMAKE_SOURCE_DIR}/3rdparty/qt)
endif()
macro_log_feature(
  HAVE_PRIVATE_QT_HEADERS
  "Qt internals"
  "Private Qt headers, necessary for painter debugging/profiling."
  "http://developer.qt.nokia.com/"
  FALSE
  ${QT_MIN_VERSION}
  "You must have a build version of Qt available. Make sure the qmake found first in your execute comes from this build version."
)

if(WIN32 OR APPLE)
  set(BUILD_TIMER_PLUGIN TRUE)
else()
  check_library_exists(rt clock_gettime "" HAVE_CLOCK_GETTIME)
  macro_log_feature(HAVE_CLOCK_GETTIME "librt" "High resolution clock for the timer profiler plugin." "part of glibc" FALSE)
  set(BUILD_TIMER_PLUGIN ${HAVE_CLOCK_GETTIME})
endif()

if(WIN32)
  add_definitions(-DUNICODE -D_UNICODE)
endif()

if(APPLE)
  # on the Mac support an extra install directory for application bundles
  set(
    INSTALL_TARGETS_DEFAULT_ARGS
    ${INSTALL_TARGETS_DEFAULT_ARGS}
    BUNDLE DESTINATION "/Applications/Qt4"
  )
endif()

if(UNIX AND NOT APPLE)
  set(DOC_INSTALL_DIR share/doc/gammaray/)
else()
  set(DOC_INSTALL_DIR .)
endif()

# TODO: find a nicer way for all this. ideally auto-detect the name mangling
# format, but at least guess a default based on OS + compiler.
option(
  GAMMARAY_UNKNOWN_CXX_MANGLED_NAMES
  "Enable if your compiler uses an unsupported C++ name mangling scheme"
  OFF
)
if(GAMMARAY_UNKNOWN_CXX_MANGLED_NAMES)
  add_definitions(-DGAMMARAY_UNKNOWN_CXX_MANGLED_NAMES)
endif()

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/config-gammaray.h.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/config-gammaray.h
)
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/config-gammaray-version.h.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/config-gammaray-version.h
)

if(CMAKE_COMPILER_IS_GNUCXX)
  check_cxx_compiler_flag(-Wunused-but-set-variable HAVE_GCC_UNUSED_BUT_SET)
  check_cxx_compiler_flag(-Wlogical-op HAVE_GCC_LOGICAL_OP)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated -Wextra -Woverloaded-virtual -Winit-self -Wmissing-include-dirs -Wunused -Wno-div-by-zero -Wundef -Wpointer-arith -Wcast-qual -Wcast-align -Wmissing-noreturn -Werror=return-type -fvisibility=hidden" )
  if(HAVE_GCC_UNUSED_BUT_SET)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wunused-but-set-variable")
  endif()
  if(HAVE_GCC_LOGICAL_OP)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wlogical-op")
  endif()
endif()

if(MINGW)
  # mingw will error out on the crazy casts in probe.cpp without this
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive")
endif()

# linker flags
if(CMAKE_SYSTEM_NAME MATCHES Linux OR CMAKE_SYSTEM_NAME STREQUAL GNU)
  if(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--fatal-warnings -Wl,--no-undefined -lc ${CMAKE_SHARED_LINKER_FLAGS} -Wl,-rpath -Wl,/usr/lib")
    set(CMAKE_MODULE_LINKER_FLAGS "-Wl,--fatal-warnings -Wl,--no-undefined -lc ${CMAKE_MODULE_LINKER_FLAGS} -Wl,-rpath -Wl,/usr/lib")
  endif()
endif()

add_subdirectory(core)
add_subdirectory(launcher)

set(GRAPHVIZ_MIN_VERSION "2.20")
find_package(Graphviz)
macro_log_feature(
  GRAPHVIZ_FOUND
  "Graphviz"
  "Graph visualization software"
  "http://www.graphviz.org/"
  FALSE
  ${GRAPHVIZ_MIN_VERSION}
  "Needed for the state machine visualizer plugin"
)
if(GRAPHVIZ_FOUND)
  add_definitions(-DGRAPHVIZ_MAJOR_VERSION=${GRAPHVIZ_MAJOR_VERSION} -DGRAPHVIZ_MINOR_VERSION=${GRAPHVIZ_MINOR_VERSION})
endif()

#VTK discovery works a lot better if you give CMake a hint using the VTK_DIR variable
find_path(VTK_DIR VTKConfig.cmake
  /usr/lib64/vtk /usr/lib/vtk /usr/local/lib64/vtk /usr/local/lib/vtk
)
find_package(VTK)
macro_log_feature(
  VTK_FOUND
  "VTK"
  "Visualization Toolkit"
  "http://www.vtk.org"
  FALSE
  ""
  "Needed for the object visualization plugin"
)

if(UNIX AND NOT APPLE)
  set(XDG_APPS_INSTALL_DIR share/applications)
  install(FILES GammaRay.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})

  install(
    FILES resources/GammaRay-16x16.png
    DESTINATION share/icons/hicolor/16x16/apps RENAME GammaRay.png
  )
  install(
    FILES resources/GammaRay-32x32.png
    DESTINATION share/icons/hicolor/32x32/apps RENAME GammaRay.png
  )
  install(
    FILES resources/GammaRay-48x48.png
    DESTINATION share/icons/hicolor/48x48/apps RENAME GammaRay.png
  )
  install(
    FILES resources/GammaRay-128x128.png
    DESTINATION share/icons/hicolor/128x128/apps RENAME GammaRay.png
  )
  install(
    FILES resources/GammaRay-256x256.png
    DESTINATION share/icons/hicolor/256x256/apps RENAME GammaRay.png
  )
  install(
    FILES resources/GammaRay-512x512.png
    DESTINATION share/icons/hicolor/512x512/apps RENAME GammaRay.png
  )
endif()

set(LICENSE_FILE "License.txt")
set(README_FILE "ReadMe.txt")
if(NOT APPLE)
  install(FILES "${LICENSE_FILE}" "${README_FILE}" DESTINATION ${DOC_INSTALL_DIR})
endif()

find_program(CPPCHECK_EXECUTABLE cppcheck)
if(CPPCHECK_EXECUTABLE)
  set(_cppcheck_flags "-I${CMAKE_CURRENT_BINARY_DIR}")
  get_directory_property(_inc_dirs INCLUDE_DIRECTORIES)
  foreach(_current ${_inc_dirs})
    set(_cppcheck_flags ${_cppcheck_flags} "-I${_current}")
  endforeach()
  get_directory_property(_defs COMPILE_DEFINITIONS)
  foreach(_current ${_defs})
    set(_cppcheck_flags ${_cppcheck_flags} "-D${_current}")
  endforeach()

  add_custom_target(cppcheck
    COMMAND ${CPPCHECK_EXECUTABLE} --enable=all -j 4 --suppress=*:${QT_INCLUDE_DIR}* ${_cppcheck_flags}
      -i${CMAKE_CURRENT_SOURCE_DIR}/3rdparty
      -i${CMAKE_CURRENT_SOURCE_DIR}/tests
    ${CMAKE_CURRENT_SOURCE_DIR}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "Running the cppcheck static code checker"
  )
endif()

if(UNIX)
  #man page generation using pod2man
  add_custom_command(
    OUTPUT ${CMAKE_BINARY_DIR}/gammaray.1
    COMMAND pod2man -c "KDAB Products" -r "\"${GAMMARAY_VERSION}\"" -s 1 ${CMAKE_SOURCE_DIR}/gammaray.pod ${CMAKE_BINARY_DIR}/gammaray.1
    DEPENDS ${CMAKE_SOURCE_DIR}/gammaray.pod
  )
  add_custom_target(man ALL DEPENDS ${CMAKE_BINARY_DIR}/gammaray.1)

  install(FILES ${CMAKE_BINARY_DIR}/gammaray.1 DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1)

  file(GLOB API_LIST include/*.h include/*.dox images/*.html)

  #apidox generation using doxygen
  add_custom_command(
    OUTPUT ${CMAKE_BINARY_DIR}/apidocs/html/index.html
    COMMAND echo \"PROJECT_NUMBER = ${GAMMARAY_VERSION}\" > ${CMAKE_BINARY_DIR}/versfoo
    COMMAND echo \"INPUT = ${CMAKE_SOURCE_DIR}/include\" > ${CMAKE_BINARY_DIR}/inputfoo
    COMMAND echo \"IMAGE_PATH = ${CMAKE_SOURCE_DIR}/images\" > ${CMAKE_BINARY_DIR}/imgfoo
    COMMAND echo \"HTML_FOOTER = ${CMAKE_SOURCE_DIR}/images/footer.html\" > ${CMAKE_BINARY_DIR}/footfoo
    COMMAND cat ${CMAKE_SOURCE_DIR}/Doxyfile
                ${CMAKE_BINARY_DIR}/versfoo
                ${CMAKE_BINARY_DIR}/inputfoo
                ${CMAKE_BINARY_DIR}/imgfoo
                ${CMAKE_BINARY_DIR}/footfoo | doxygen -
    DEPENDS ${API_LIST} ${CMAKE_SOURCE_DIR}/Doxyfile
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
  )
  add_custom_target(docs
    DEPENDS ${CMAKE_BINARY_DIR}/apidocs/html/index.html
  )

endif()

include(ExternalProject)

add_subdirectory(include)
add_subdirectory(tests)
add_subdirectory(plugins)

macro_display_feature_log()

=== core/CMakeLists.txt ===
add_subdirectory(tools)

include_directories(
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/3rdparty
  ${CMAKE_CURRENT_SOURCE_DIR}

  ${CMAKE_BINARY_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
)

set(gammaray_srcs
  ${CMAKE_SOURCE_DIR}/3rdparty/kde/krecursivefilterproxymodel.cpp
  ${CMAKE_SOURCE_DIR}/3rdparty/kde/kfilterproxysearchline.cpp
  ${CMAKE_SOURCE_DIR}/3rdparty/qt/resourcemodel.cpp

  util.cpp
  aboutpluginsdialog.cpp
  mainwindow.cpp
  metaobject.cpp
  metaobjecttreemodel.cpp
  metaobjectrepository.cpp
  metaproperty.cpp
  metapropertymodel.cpp
  pluginmanager.cpp
  probe.cpp
  proxydetacher.cpp
  objectlistmodel.cpp
  objectpropertymodel.cpp
  objectdynamicpropertymodel.cpp
  objectstaticpropertymodel.cpp
  objectclassinfomodel.cpp
  objectmethodmodel.cpp
  objectenummodel.cpp
  objecttreemodel.cpp
  connectionmodel.cpp
  connectionfilterproxymodel.cpp
  methodinvocationdialog.cpp
  methodargumentmodel.cpp
  multisignalmapper.cpp
  toolmodel.cpp
  proxydetacher.cpp
  proxytoolfactory.cpp
  sidepane.cpp
  palettemodel.cpp
  propertywidget.cpp

  propertyeditor/propertycoloreditor.cpp
  propertyeditor/propertydoublepaireditor.cpp
  propertyeditor/propertyeditorfactory.cpp
  propertyeditor/propertyextendededitor.cpp
  propertyeditor/propertyfonteditor.cpp
  propertyeditor/propertyintpaireditor.cpp
  propertyeditor/propertypaletteeditor.cpp
  propertyeditor/palettedialog.cpp

  hooking/abstractfunctionoverwriter.cpp
  hooking/functionoverwriterfactory.cpp
  hooking/winfunctionoverwriter.cpp
  hooking/unixfunctionoverwriter.cpp

  tools/modelinspector/modeltester.cpp
  tools/modelinspector/modelmodel.cpp
  tools/modelinspector/modelcellmodel.cpp
  tools/sceneinspector/graphicsview.cpp
  tools/sceneinspector/graphicssceneview.cpp
  tools/sceneinspector/scenemodel.cpp
  tools/metatypebrowser/metatypesmodel.cpp
  tools/fontbrowser/fontmodel.cpp
  tools/localeinspector/localemodel.cpp
  tools/localeinspector/localedataaccessor.cpp
  tools/localeinspector/localeaccessormodel.cpp
  tools/codecbrowser/codecmodel.cpp
  tools/textdocumentinspector/textdocumentmodel.cpp
  tools/textdocumentinspector/textdocumentformatmodel.cpp
  tools/textdocumentinspector/textdocumentcontentview.cpp
  tools/messagehandler/messagehandler.cpp
  tools/messagehandler/messagemodel.cpp
  tools/codecbrowser/codecbrowser.cpp
  tools/connectioninspector/connectioninspector.cpp
  tools/fontbrowser/fontbrowser.cpp
  tools/localeinspector/localeinspector.cpp
  tools/metaobjectbrowser/metaobjectbrowser.cpp
  tools/metatypebrowser/metatypebrowser.cpp
  tools/modelinspector/modelinspector.cpp
  tools/modelinspector/modelinspectorwidget.cpp
  tools/objectinspector/objectinspector.cpp
  tools/resourcebrowser/resourcebrowser.cpp
  tools/resourcebrowser/resourcefiltermodel.cpp
  tools/sceneinspector/sceneinspector.cpp
  tools/selectionmodelinspector/selectionmodelinspector.cpp
  tools/textdocumentinspector/textdocumentinspector.cpp
  tools/widgetinspector/widgetinspector.cpp
  tools/widgetinspector/overlaywidget.cpp
  tools/widgetinspector/widgettreemodel.cpp
  tools/widgetinspector/widgetpreviewwidget.cpp
  tools/styleinspector/styleinspector.cpp
  tools/styleinspector/pixelmetricmodel.cpp
  tools/styleinspector/standardiconmodel.cpp
  tools/styleinspector/primitivemodel.cpp
  tools/styleinspector/controlmodel.cpp
  tools/styleinspector/styleoption.cpp
  tools/styleinspector/abstractstyleelementmodel.cpp
  tools/styleinspector/abstractstyleelementstatetable.cpp
  tools/styleinspector/styleelementstatetablepage.cpp
  tools/styleinspector/complexcontrolmodel.cpp
  tools/styleinspector/dynamicproxystyle.cpp
)

if(HAVE_PRIVATE_QT_HEADERS)
  set(gammaray_srcs
    ${gammaray_srcs}
    paintbuffermodel.cpp
    paintbufferviewer.cpp
    paintbufferreplaywidget.cpp
  )
endif()

if(NOT WIN32)
  set(gammaray_srcs ${gammaray_srcs} tools/messagehandler/backtrace_unix.cpp)
elseif(MINGW)
  set(gammaray_srcs ${gammaray_srcs} tools/messagehandler/backtrace_dummy.cpp)
else()
  set(gammaray_srcs ${gammaray_srcs}
    tools/messagehandler/backtrace_win.cpp
    tools/messagehandler/StackWalker.cpp)
endif()

qt4_automoc(${gammaray_srcs})
qt4_wrap_ui(gammaray_srcs
  mainwindow.ui
  propertywidget.ui
  methodinvocationdialog.ui
  paintbufferviewer.ui

  propertyeditor/propertydoublepaireditor.ui
  propertyeditor/propertyextendededitor.ui
  propertyeditor/propertyintpaireditor.ui
  propertyeditor/palettedialog.ui

  tools/sceneinspector/graphicssceneview.ui
  tools/codecbrowser/codecbrowser.ui
  tools/connectioninspector/connectioninspector.ui
  tools/fontbrowser/fontbrowser.ui
  tools/localeinspector/localeinspector.ui
  tools/messagehandler/messagehandler.ui
  tools/metatypebrowser/metatypebrowser.ui
  tools/modelinspector/modelinspectorwidget.ui
  tools/objectinspector/objectinspector.ui
  tools/resourcebrowser/resourcebrowser.ui
  tools/sceneinspector/sceneinspector.ui
  tools/selectionmodelinspector/selectionmodelinspector.ui
  tools/styleinspector/styleinspector.ui
  tools/textdocumentinspector/textdocumentinspector.ui
  tools/widgetinspector/widgetinspector.ui
  tools/styleinspector/styleelementstatetablepage.ui
)

qt4_add_resources(gammaray_srcs ${CMAKE_SOURCE_DIR}/resources/gammaray.qrc)

add_definitions(-DMAKE_GAMMARAY_LIB)
add_library(gammaray_probe
  SHARED ${gammaray_srcs}
)
target_link_libraries(gammaray_probe
  ${QT_QTCORE_LIBRARIES}
  ${QT_QTGUI_LIBRARIES}
)
if(NOT WIN32)
  target_link_libraries(gammaray_probe dl)
endif()
set_target_properties(gammaray_probe PROPERTIES PREFIX "")

install(TARGETS gammaray_probe ${INSTALL_TARGETS_DEFAULT_ARGS})

=== tests/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_BINARY_DIR})

qt4_automoc(test_connections.cpp)

add_executable(connectiontest test_connections.cpp)

target_link_libraries(connectiontest
  ${QT_QTCORE_LIBRARIES}
  ${QT_QTGUI_LIBRARIES}
  ${QT_QTTEST_LIBRARIES}
)

qt4_automoc(attachhelper.cpp)

add_executable(attachhelper attachhelper.cpp)

target_link_libraries(attachhelper ${QT_QTCORE_LIBRARIES})

if(UNIX AND NOT APPLE)
  add_test(connectiontest-preload
    ${PROJECT_BINARY_DIR}/bin/gammaray -unittest -i preload
    ${PROJECT_BINARY_DIR}/bin/connectiontest
  )
  add_test(connectiontest-style
    ${PROJECT_BINARY_DIR}/bin/gammaray -unittest -i style
    ${PROJECT_BINARY_DIR}/bin/connectiontest
  )

  set(RUN_FILTER_TESTS OFF
    CACHE BOOL "Run filter tests which fail due to a bug in QSortFilterProxyModel"
  )
  if(RUN_FILTER_TESTS)
    add_test(connectiontest-preload-filter
      ${PROJECT_BINARY_DIR}/bin/gammaray -unittest -filtertest -i preload
      ${PROJECT_BINARY_DIR}/bin/connectiontest
    )
    add_test(connectiontest-preload-filter-modeltest
      ${PROJECT_BINARY_DIR}/bin/gammaray -unittest -modeltest -filtertest -i preload
      ${PROJECT_BINARY_DIR}/bin/connectiontest
    )
    add_test(connectiontest-style-filter
      ${PROJECT_BINARY_DIR}/bin/gammaray -unittest -filtertest -i style
      ${PROJECT_BINARY_DIR}/bin/connectiontest
    )
  endif()

  find_program(GDB_EXECUTABLE gdb)
  if(GDB_EXECUTABLE)
    add_test(connectiontest-gdb
      ${PROJECT_BINARY_DIR}/bin/gammaray -unittest -i gdb
      ${PROJECT_BINARY_DIR}/bin/connectiontest
    )
    add_test(attachtest-gdb
      ${PROJECT_BINARY_DIR}/bin/attachhelper ${PROJECT_BINARY_DIR}/bin/gammaray gdb
      ${PROJECT_BINARY_DIR}/bin/connectiontest
    )
    if(RUN_FILTER_TESTS)
      add_test(connectiontest-gdb-filter
        ${PROJECT_BINARY_DIR}/bin/gammaray -unittest -filtertest -i gdb
        ${PROJECT_BINARY_DIR}/bin/connectiontest
      )
    endif()
  endif()
endif()

add_subdirectory(manual)

=== tests/manual/CMakeLists.txt ===
include_directories(
  ${CMAKE_SOURCE_DIR}

  ${CMAKE_CURRENT_BINARY_DIR}
)

add_executable(propertywidgettest
  propertywidgettest.cpp
)

target_link_libraries(propertywidgettest
  ${QT_QTCORE_LIBRARIES}
  ${QT_QTGUI_LIBRARIES}
  gammaray_probe
)

=== debian/changelog ===
gammaray (1.1.98) beta; urgency=low

  * 1.1.98 beta release

 -- Allen Winter <allen.winter@kdab.com>  Wed, 27 Jun 2012 14:10:14 +0000

=== debian/control ===
Source: gammaray
Section: Miscellaneous
Priority: optional
Maintainer: Allen Winter <allen.winter@kdab.com>
Build-Depends: debhelper (>= 4.1.16), cdbs, cmake, libqt4-dev, libqtwebkit-dev, graphviz-dev

Package: gammaray
Architecture: any
Depends: ${shlibs:Depends}, graphviz
Description: A tool to poke around in a Qt-application
 GammaRay is a tool for examining the internals of a Qt application
 and to some extent also manipulate it. GammaRay uses injection
 methods to hook into an application at runtime and provide access to
 a wide variety of interesting information. It provides easy ways of
 navigating through the complex internal structures you find in some
 Qt frameworks, such as QGraphicsView, model/view, QTextDocument,
 state machines and more.

## gammaray 1.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 
 set(GAMMARAY_VERSION_MAJOR "1")
 set(GAMMARAY_VERSION_MINOR "2")
-set(GAMMARAY_VERSION_PATCH "50")
+set(GAMMARAY_VERSION_PATCH "1")
 set(GAMMARAY_VERSION "${GAMMARAY_VERSION_MAJOR}.${GAMMARAY_VERSION_MINOR}.${GAMMARAY_VERSION_PATCH}")
 set(GAMMARAY_VERSION_STRING "${GAMMARAY_VERSION}")
 
@@ -198,7 +198,7 @@
 if(CMAKE_COMPILER_IS_GNUCXX)
   check_cxx_compiler_flag(-Wunused-but-set-variable HAVE_GCC_UNUSED_BUT_SET)
   check_cxx_compiler_flag(-Wlogical-op HAVE_GCC_LOGICAL_OP)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated -Wextra -Woverloaded-virtual -Winit-self -Wmissing-include-dirs -Wunused -Wno-div-by-zero -Wundef -Wpointer-arith -Wcast-qual -Wcast-align -Wmissing-noreturn -Werror=return-type -fvisibility=hidden" )
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated -Wextra -Woverloaded-virtual -Winit-self -Wmissing-include-dirs -Wunused -Wno-div-by-zero -Wundef -Wpointer-arith -Wcast-qual -Wcast-align -Wmissing-noreturn -Werror=return-type -fvisibility=hidden")
   if(HAVE_GCC_UNUSED_BUT_SET)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wunused-but-set-variable")
   endif()
@@ -215,8 +215,8 @@
 # linker flags
 if(CMAKE_SYSTEM_NAME MATCHES Linux OR CMAKE_SYSTEM_NAME STREQUAL GNU)
   if(CMAKE_COMPILER_IS_GNUCXX)
-    set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--fatal-warnings -Wl,--no-undefined -lc ${CMAKE_SHARED_LINKER_FLAGS} -Wl,-rpath -Wl,/usr/lib")
-    set(CMAKE_MODULE_LINKER_FLAGS "-Wl,--fatal-warnings -Wl,--no-undefined -lc ${CMAKE_MODULE_LINKER_FLAGS} -Wl,-rpath -Wl,/usr/lib")
+    set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--fatal-warnings -Wl,--no-undefined -lc ${CMAKE_SHARED_LINKER_FLAGS}")
+    set(CMAKE_MODULE_LINKER_FLAGS "-Wl,--fatal-warnings -Wl,--no-undefined -lc ${CMAKE_MODULE_LINKER_FLAGS}")
   endif()
 endif()

=== core/CMakeLists.txt ===
--- 
+++ 
@@ -10,15 +10,14 @@
 )
 
 set(gammaray_srcs
-  ${CMAKE_SOURCE_DIR}/3rdparty/kde/krecursivefilterproxymodel.cpp
-  ${CMAKE_SOURCE_DIR}/3rdparty/kde/kfilterproxysearchline.cpp
-  ${CMAKE_SOURCE_DIR}/3rdparty/qt/resourcemodel.cpp
+  ../3rdparty/kde/krecursivefilterproxymodel.cpp
+  ../3rdparty/kde/kfilterproxysearchline.cpp
+  ../3rdparty/qt/resourcemodel.cpp
 
   util.cpp
   aboutpluginsdialog.cpp
   mainwindow.cpp
   metaobject.cpp
-  metaobjecttreemodel.cpp
   metaobjectrepository.cpp
   metaproperty.cpp
   metapropertymodel.cpp
@@ -80,7 +79,6 @@
   tools/connectioninspector/connectioninspector.cpp
   tools/fontbrowser/fontbrowser.cpp
   tools/localeinspector/localeinspector.cpp
-  tools/metaobjectbrowser/metaobjectbrowser.cpp
   tools/metatypebrowser/metatypebrowser.cpp
   tools/modelinspector/modelinspector.cpp
   tools/modelinspector/modelinspectorwidget.cpp

=== include/CMakeLists.txt ===
set(GAMMARAY_HEADERS
  metatypedeclarations.h
  objectmodel.h
  objectmodelbase.h
  objecttypefilterproxymodel.h
  probeinterface.h
  singlecolumnobjectproxymodel.h
  toolfactory.h
  util.h
)

install(FILES ${GAMMARAY_HEADERS} DESTINATION include/gammaray/)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -62,5 +62,3 @@
     endif()
   endif()
 endif()
-
-add_subdirectory(manual)

=== core/tools/CMakeLists.txt ===
include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
)

# Disabled in Qt5 - QFormBuilder include is not installed
if(NOT Qt5Core_FOUND)
  add_subdirectory(widgetinspector)
endif()

=== launcher/injector/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(gammaray_injector_style_srcs injectorstyleplugin.cpp)
qt4_automoc(${gammaray_injector_style_srcs})

add_library(gammaray_injector_style MODULE ${gammaray_injector_style_srcs})

target_link_libraries(gammaray_injector_style
  ${QT_QTCORE_LIBRARIES}
  ${QT_QTGUI_LIBRARIES}
)

set_target_properties(gammaray_injector_style
  PROPERTIES PREFIX ""
  LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib/plugins/styles
)

install(
  TARGETS gammaray_injector_style
  DESTINATION ${PLUGIN_INSTALL_DIR}/styles
)

=== plugins/actioninspector/CMakeLists.txt ===
include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
)

set(gammaray_actioninspector_plugin_srcs
  ../../3rdparty/kde/kfilterproxysearchline.cpp
  ../../3rdparty/kde/krecursivefilterproxymodel.cpp

  actionvalidator.cpp
  actioninspector.cpp
  actionmodel.cpp
)

qt4_automoc(${gammaray_actioninspector_plugin_srcs})

gammaray_add_plugin(gammaray_actioninspector_plugin
  gammaray_actioninspector.desktop
  ${gammaray_actioninspector_plugin_srcs}
)

target_link_libraries(gammaray_actioninspector_plugin
  ${QT_QTCORE_LIBRARIES}
  ${QT_QTGUI_LIBRARIES}
  gammaray_probe
)

=== plugins/objectvisualizer/CMakeLists.txt ===
# VTK includes QtGui/... stuff => breaks compilation with Qt5
if(NOT Qt5Core_FOUND)

if(VTK_FOUND)

add_definitions(-DHAVE_VTK -DVTK_EXCLUDE_STRSTREAM_HEADERS)

include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
  ${VTK_INCLUDE_DIRS}
)

link_directories(${VTK_LIBRARY_DIRS})

set(gammaray_objectvisualizer_plugin_srcs
  ../../3rdparty/kde/kfilterproxysearchline.cpp
  ../../3rdparty/kde/krecursivefilterproxymodel.cpp

  objectvisualizer.cpp
  vtkcontainer.cpp
  vtkpanel.cpp
  vtkwidget.cpp
)

qt4_automoc(${gammaray_objectvisualizer_plugin_srcs})

gammaray_add_plugin(gammaray_objectvisualizer_plugin
  gammaray_objectvisualizer.desktop
  ${gammaray_objectvisualizer_plugin_srcs}
)

target_link_libraries(gammaray_objectvisualizer_plugin
  ${QT_QTCORE_LIBRARIES}
  ${QT_QTGUI_LIBRARIES}
  QVTK
  gammaray_probe
)

endif()

endif()

=== plugins/scriptenginedebugger/CMakeLists.txt ===
include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
)

set(gammaray_scriptenginedebugger_plugin_srcs
  scriptenginedebugger.cpp
)

qt4_automoc(${gammaray_scriptenginedebugger_plugin_srcs})

qt4_wrap_ui(gammaray_scriptenginedebugger_plugin_srcs scriptenginedebugger.ui)

gammaray_add_plugin(gammaray_scriptenginedebugger_plugin
  gammaray_scriptenginedebugger.desktop
  ${gammaray_scriptenginedebugger_plugin_srcs}
)

target_link_libraries(gammaray_scriptenginedebugger_plugin
  ${QT_QTCORE_LIBRARIES}
  ${QT_QTGUI_LIBRARIES}
  ${QT_QTSCRIPT_LIBRARIES}
  ${QT_QTSCRIPTTOOLS_LIBRARIES}
  gammaray_probe
)

=== plugins/statemachineviewer/CMakeLists.txt ===
if(GRAPHVIZ_FOUND)

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${GRAPHVIZ_INCLUDE_DIR}
)

set(gammaray_statemachineviewer_plugin_srcs
  # this part depends on graphviz
  gvgraph/gvgraph.cpp
  gvgraph/gvgraphitems.cpp

  statemachineview.cpp
  statemachineviewer.cpp
  statemachinewatcher.cpp

  transitionmodel.cpp
  statemodel.cpp
)

qt4_automoc(${gammaray_statemachineviewer_plugin_srcs})

qt4_wrap_ui(gammaray_statemachineviewer_plugin_srcs statemachineviewer.ui)

set(gammaray_statemachineviewer_plugin_libs
  ${QT_QTCORE_LIBRARIES}
  ${QT_QTGUI_LIBRARIES}

  ${GRAPHVIZ_GRAPH_LIBRARY}
  ${GRAPHVIZ_GVC_LIBRARY}
  gammaray_probe
)

gammaray_add_plugin(gammaray_statemachineviewer_plugin
  gammaray_statemachineviewer.desktop
  ${gammaray_statemachineviewer_plugin_srcs}
)

target_link_libraries(gammaray_statemachineviewer_plugin
  ${gammaray_statemachineviewer_plugin_libs}
)

add_executable(statemachineviewer_test
  gvgraph/gvgraph.cpp
  gvgraph/gvgraphitems.cpp

  test_main.cpp
)

target_link_libraries(statemachineviewer_test ${gammaray_statemachineviewer_plugin_libs})

endif()

=== plugins/timertop/CMakeLists.txt ===
if(BUILD_TIMER_PLUGIN)

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
)

set(gammaray_timertop_plugin_srcs
  timertop.cpp
  timermodel.cpp
  timerinfo.cpp
  functioncalltimer.cpp
)

qt4_automoc(${gammaray_timertop_plugin_srcs})

qt4_wrap_ui(gammaray_timertop_plugin_srcs
  timertop.ui
)

gammaray_add_plugin(gammaray_timertop_plugin
  gammaray_timertop.desktop
  ${gammaray_timertop_plugin_srcs}
)

target_link_libraries(gammaray_timertop_plugin
  ${QT_QTCORE_LIBRARIES}
  ${QT_QTGUI_LIBRARIES}
  gammaray_probe
)

if(NOT WIN32 AND NOT APPLE)
  target_link_libraries(gammaray_timertop_plugin rt)
endif()

endif()

=== plugins/webinspector/CMakeLists.txt ===
include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
)

set(gammaray_webinspector_plugin_srcs
  webinspector.cpp
)

qt4_automoc(${gammaray_webinspector_plugin_srcs})

qt4_wrap_ui(gammaray_webinspector_plugin_srcs webinspector.ui)

gammaray_add_plugin(gammaray_webinspector_plugin
  gammaray_webinspector.desktop
  ${gammaray_webinspector_plugin_srcs}
)

target_link_libraries(gammaray_webinspector_plugin
  ${QT_QTCORE_LIBRARIES}
  ${QT_QTGUI_LIBRARIES}
  ${QT_QTWEBKIT_LIBRARIES}
  gammaray_probe
)

=== debian/changelog ===
gammaray (1.2.1-2) unstable; urgency=low

  * Build-depend on libgraphviz-dev instead of dummy transitional
    graphviz-dev.
  * Fix build on GNU Hurd.
  * Don't build core/hooking/*.cpp. Function overwriter is used only on
    Windows and Mac, disabling it fixes building GammaRay on other archs
    than i386 and amd64.

 -- Jakub Adam <jakub.adam@ktknet.cz>  Thu, 06 Sep 2012 15:45:25 +0200

gammaray (1.2.1-1) unstable; urgency=low

  * Initial release. (Closes: #654667)

 -- Jakub Adam <jakub.adam@ktknet.cz>  Tue, 21 Aug 2012 10:48:10 +0200

=== debian/control ===
Source: gammaray
Priority: optional
Section: devel
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Jakub Adam <jakub.adam@ktknet.cz>
Build-Depends: debhelper (>= 9),
               cmake,
               libqt4-dev,
               libqt4-private-dev,
               libqtwebkit-dev,
               libgraphviz-dev,
               gdb,
               xauth,
               xvfb
Standards-Version: 3.9.3
Vcs-Git: git://anonscm.debian.org/pkg-kde/kde-extras/gammaray.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-kde/kde-extras/gammaray.git
Homepage: http://www.kdab.com/gammaray

Package: gammaray
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: gdb
Description: Tool for examining the internals of Qt application
 GammaRay is a tool for examining the internals of a Qt application and
 to some extent also manipulate it. GammaRay uses injection methods to
 hook into an application at runtime and provide access to a wide variety
 of interesting information. It provides easy ways of navigating through
 the complex internal structures you find in some Qt frameworks, such as
 QGraphicsView, model/view, QTextDocument, state machines and more.

Package: gammaray-dev
Architecture: any
Section: libdevel
Depends: gammaray (= ${binary:Version}),
         ${misc:Depends}
Description: GammaRay plugin development files
 GammaRay is a tool for examining the internals of a Qt application and
 to some extent also manipulate it. GammaRay uses injection methods to
 hook into an application at runtime and provide access to a wide variety
 of interesting information. It provides easy ways of navigating through
 the complex internal structures you find in some Qt frameworks, such as
 QGraphicsView, model/view, QTextDocument, state machines and more.
 .
 This package contains header files used for building 3rd party GammaRay
 plugins.

Package: gammaray-dbg
Architecture: any
Section: debug
Priority: extra
Depends: gammaray (= ${binary:Version}),
         ${misc:Depends}
Description: debugging symbols for gammaray
 GammaRay is a tool for examining the internals of a Qt application and
 to some extent also manipulate it. GammaRay uses injection methods to
 hook into an application at runtime and provide access to a wide variety
 of interesting information. It provides easy ways of navigating through
 the complex internal structures you find in some Qt frameworks, such as
 QGraphicsView, model/view, QTextDocument, state machines and more.
 .
 This package contains the debugging symbols for gammaray.

## gammaray 1.2.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 
 set(GAMMARAY_VERSION_MAJOR "1")
 set(GAMMARAY_VERSION_MINOR "2")
-set(GAMMARAY_VERSION_PATCH "1")
+set(GAMMARAY_VERSION_PATCH "2")
 set(GAMMARAY_VERSION "${GAMMARAY_VERSION_MAJOR}.${GAMMARAY_VERSION_MINOR}.${GAMMARAY_VERSION_PATCH}")
 set(GAMMARAY_VERSION_STRING "${GAMMARAY_VERSION}")
 
@@ -185,6 +185,9 @@
 if(GAMMARAY_UNKNOWN_CXX_MANGLED_NAMES)
   add_definitions(-DGAMMARAY_UNKNOWN_CXX_MANGLED_NAMES)
 endif()
+
+include(CheckIncludeFiles)
+check_include_files(stdint.h HAVE_STDINT_H)
 
 configure_file(
   ${CMAKE_CURRENT_SOURCE_DIR}/config-gammaray.h.cmake

=== core/CMakeLists.txt ===
--- 
+++ 
@@ -53,11 +53,6 @@
   propertyeditor/propertypaletteeditor.cpp
   propertyeditor/palettedialog.cpp
 
-  hooking/abstractfunctionoverwriter.cpp
-  hooking/functionoverwriterfactory.cpp
-  hooking/winfunctionoverwriter.cpp
-  hooking/unixfunctionoverwriter.cpp
-
   tools/modelinspector/modeltester.cpp
   tools/modelinspector/modelmodel.cpp
   tools/modelinspector/modelcellmodel.cpp
@@ -104,6 +99,16 @@
   tools/styleinspector/complexcontrolmodel.cpp
   tools/styleinspector/dynamicproxystyle.cpp
 )
+
+if(WIN32 OR APPLE)
+  set(gammaray_srcs
+    ${gammaray_srcs}
+    hooking/abstractfunctionoverwriter.cpp
+    hooking/functionoverwriterfactory.cpp
+    hooking/winfunctionoverwriter.cpp
+    hooking/unixfunctionoverwriter.cpp
+  )
+endif()
 
 if(HAVE_PRIVATE_QT_HEADERS)
   set(gammaray_srcs

=== launcher/CMakeLists.txt ===
add_subdirectory(injector)

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}

  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/3rdparty
)

set(gammaray_runner_srcs
  injector/abstractinjector.cpp
  injector/injectorfactory.cpp
  injector/preloadinjector.cpp
  injector/styleinjector.cpp
  injector/windllinjector.cpp
  injector/interactiveprocess.cpp
  injector/preloadcheck.cpp

  probefinder.cpp
  main.cpp
  promolabel.cpp
  splashscreen.cpp
  launcherwindow.cpp
  launchpage.cpp
  selftestpage.cpp

  attachdialog.cpp
  processmodel.cpp
  processfiltermodel.cpp

  ${CMAKE_SOURCE_DIR}/3rdparty/kde/krecursivefilterproxymodel.cpp
  ${CMAKE_SOURCE_DIR}/3rdparty/kde/kfilterproxysearchline.cpp
)
if(NOT WIN32)
  set(gammaray_runner_srcs
    ${gammaray_runner_srcs}
    injector/gdbinjector.cpp
    processlist_unix.cpp
  )
else()
  set(gammaray_runner_srcs
    ${gammaray_runner_srcs}
    processlist_win.cpp
  )
endif()

qt4_wrap_ui(gammaray_runner_srcs
  attachdialog.ui
  launcherwindow.ui
  launchpage.ui
  selftestpage.ui
)
# TODO we don't need all the class icons here, so split the qrc file accordingly
qt4_add_resources(gammaray_runner_srcs ${CMAKE_SOURCE_DIR}/resources/gammaray.qrc)
qt4_automoc(${gammaray_runner_srcs})

add_executable(gammaray ${gammaray_runner_srcs})

target_link_libraries(gammaray ${QT_QTCORE_LIBRARIES} ${QT_QTGUI_LIBRARIES})
if(UNIX AND NOT APPLE)
  target_link_libraries(gammaray dl) # for preload check
endif()

install(TARGETS gammaray ${INSTALL_TARGETS_DEFAULT_ARGS})

=== plugins/CMakeLists.txt ===
include_directories(
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/3rdparty
)

add_subdirectory(actioninspector)
add_subdirectory(objectvisualizer)

if(QT_QTSCRIPTTOOLS_FOUND OR Qt5ScriptTools_FOUND)
  add_subdirectory(scriptenginedebugger)
endif()

add_subdirectory(statemachineviewer)
add_subdirectory(timertop)

if(QT_QTWEBKIT_FOUND OR Qt5Webkit_FOUND)
  add_subdirectory(webinspector)
endif()

=== plugins/objectvisualizer/CMakeLists.txt ===
--- 
+++ 
@@ -32,6 +32,7 @@
 target_link_libraries(gammaray_objectvisualizer_plugin
   ${QT_QTCORE_LIBRARIES}
   ${QT_QTGUI_LIBRARIES}
+  ${VTK_LIBRARIES}
   QVTK
   gammaray_probe
 )

=== debian/changelog ===
gammaray (1.2.2-1) unstable; urgency=low

  * New upstream release.
  * Removed d/patches/dont-build-functionoverwriter.patch and
    debian/patches/gnu-hurd-build-fix.patch (applied upstream).
  * Refreshed d/patches/gammaray-probe-versioned-soname.patch.
  * Bump Standards-Version to 3.9.4.

 -- Jakub Adam <jakub.adam@ktknet.cz>  Sat, 22 Dec 2012 18:17:04 +0100

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                gdb,
                xauth,
                xvfb
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Vcs-Git: git://anonscm.debian.org/pkg-kde/kde-extras/gammaray.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-kde/kde-extras/gammaray.git
 Homepage: http://www.kdab.com/gammaray

=== debian/rules ===
#!/usr/bin/make -f

.PHONY: override_dh_auto_configure override_dh_auto_test override_dh_auto_install override_dh_installdocs override_dh_strip override_dh_clean

%:
	dh $@ --parallel

override_dh_auto_configure:
	# Move away bundled Qt private headers so that system versions are used
	if [ -d 3rdparty/qt/private ]; then \
		mv 3rdparty/qt/private 3rdparty/qt/private.dont.use; \
	fi

	dh_auto_configure

override_dh_auto_test:
	xvfb-run dh_auto_test

override_dh_auto_install:
	dh_auto_install
	rm -f debian/tmp/usr/share/doc/gammaray/License.txt

override_dh_installdocs:
	dh_installdocs --link-doc=gammaray

override_dh_strip:
	dh_strip --dbg-package=gammaray-dbg

override_dh_clean:
	dh_clean

	# Put back bundled Qt private headers to restore sources into original state
	if [ -d 3rdparty/qt/private.dont.use ]; then \
		mv 3rdparty/qt/private.dont.use 3rdparty/qt/private; \
	fi
